let make (l: 'a list): 'a list =
  List.fold_left
      (fun l' e ->
        if List.mem e l' then
          l'
        else
          e::l'
      )
      []
      l

let diff (s1: 'a list) (s2: 'a list): 'a list =
  List.filter (fun e -> not (List.mem e s2)) s1

let union (s1: 'a list) (s2: 'a list): 'a list =
  make (s1 @ s2)

let intersection (s1: 'a list) (s2: 'a list): 'a list =
  List.filter (fun e -> List.mem e s2) s1
