{
  exception InvalidCharacter of char
}

rule token = parse
  [' ' '\t' '\n' '\r'] { token lexbuf } (* skip blanks *)
| "size"               { SUParser.SIZE }
| "-"                  { SUParser.NONE }
| ['0'-'9']+ as n      { SUParser.INT (int_of_string n) }
| eof                  { SUParser.EOF }
| _ as ch              { raise (InvalidCharacter ch) }
